// ipl_generatorGGL: A program for generation of structure reconstruction ILP in ibm clp format.
//
// The algorithm by K.Gorbunov, V.Lyubetsky, R.Gershgorin [http://lab6.iitp.ru/en/ilp_generatorGGL/]
//
// (C)2017, Roman Gershgorin, Institute for Information Transmission Problems RAS
// E-mail: gershr{at}mail.ru
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _HELPERS_H_
#define _HELPERS_H_

#include <sstream>
#include <iostream>

template<typename T>
inline std::string ToString(const T& val)
{
	std::stringstream s;
	s << val;
	return s.str();
}

template<typename T>
inline T FromString(const std::string& str)
{
	try
	{
		T val;
		std::stringstream s(str);
		s >> val;
		return val;
	}
	catch (const std::exception& e)
	{
		std::cerr << "Convertion exception, error: " << e.what();
		throw;
	}
}

#endif // _HELPERS_H_
