// ipl_generatorGGL: A program for generation of structure reconstruction ILP in ibm clp format.
//
// The algorithm by K.Gorbunov, V.Lyubetsky, R.Gershgorin [http://lab6.iitp.ru/en/ilp_generatorGGL/]
//
// (C)2017, Roman Gershgorin, Institute for Information Transmission Problems RAS
// E-mail: gershr{at}mail.ru
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef TASK_GENERATION_H_
#define TASK_GENERATION_H_

#include "structure.h"
#include "tree.h"
#include "variables_storage.h"
#include "task_storage.h"

#include <functional>
#include <set>

using PrinterType = std::function<void(const std::string)>;

void PrintZVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, VariablesStorage& varStorage);
void PrintXVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintYVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintTVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintRVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintUVariables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintU1Variables(Storage& storage, PrinterType& print, const Structures& structures, const ParalogsMaxParam& paralogsMax, const Tree& tree, VariablesStorage& varStorage);
void PrintPVariables(Storage& storage, PrinterType& print, VariablesStorage& varStorage);

#endif // TASK_GENERATION_H_
