// ipl_generatorGGL: A program for generation of structure reconstruction ILP in ibm clp format.
//
// The algorithm by K.Gorbunov, V.Lyubetsky, R.Gershgorin [http://lab6.iitp.ru/en/ilp_generatorGGL/]
//
// (C)2017, Roman Gershgorin, Institute for Information Transmission Problems RAS
// E-mail: gershr{at}mail.ru
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _TASK_STORAGE_H_
#define _TASK_STORAGE_H_

#include <map>
#include <vector>
#include <string>

using Storage = std::map<std::string, std::vector<std::string> >;
using Expression = std::map<std::string, int>;

struct Inequality
{
	Expression lhs;
	std::string senseOfInequality;
	int rhs;
};

Inequality ParseInequality(const std::string& expression);
std::string BuildInequality(const Inequality& expression);

std::string BuildExpression(const std::map<std::string, int>& polynom);
std::map<std::string, int> ParseExpression(const std::string& expression);

void AddStringToStorage(Storage& storage, const std::string& section, const std::string& string);
void PrintTaskFromStorage(std::ostream& out, const Storage& storage);

#endif // _TASK_STORAGE_H_
